/*******************************************************************************
 									CoAN-007 application
								Web Interface implementation
*******************************************************************************/
#memmap xmem
#class auto
/*************************************************
*		 NETWORK CONFIGURATION 							 *
**************************************************/
#define TCPCONFIG 1
#define _PRIMARY_STATIC_IP  "192.168.1.55"
#define _PRIMARY_NETMASK    "255.255.255.0"
#define MY_GATEWAY          "192.168.1.1"
#define MY_NAMESERVER       "192.168.1.1"

#define USE_RABBITWEB   1
#use "dcrtcp.lib"
#use "http.lib"

/*************************************************
*  application modules for this project			 *
**************************************************/
#use "iweb.lib"     		//web interface objects
#use "config.lib"	  		//config objects
#use "datetime.lib"  	//date&time utilities

/*************************************************
*		variables for samples simulations			 *
**************************************************/
float ad_inputs[8];
long qd_reading;
unsigned long IC1counter, IC2counter;

/*************************************************
*		functions for samples simulations			 *
**************************************************/
long qdRead()
{
   return (long)(10*(rand()- 0.5))%10;
}
float get_measure( int channel)
{
  return (rand()-0.5)/10 + 5567;
}
void icx_getcounts()
{
 IC1counter = (unsigned long) ( (rand()-0.5)*5)%5 +60;
 IC2counter = (unsigned long) ( (rand()-0.5)*5)%5 +75;
}

main()
{
	int channel, result;

   //Initilizes the configuracion data
   cfgInit();

	//Web initialization
 	iweb_init();

	//Web Server Strat Up
	sock_init_or_exit(1);
   http_init();
   tcp_reserveport(80);

	while(1){
      http_handler();//Web server attention...

      /***********************************************************************
       * Simulate AD Samples
       **********************************************************************/
      costate
      {
			for(channel = 0; channel <= 7; channel++)
			{  // simulate sample for each channel
				ad_inputs[channel] = get_measure(channel);
			}
         waitfor( DelayMs(SAMPLEINTERVAL) );
      }
      /***********************************************************************
       * Simulate Quadrature Detector
       **********************************************************************/
		costate
      {  //take QD simulated counter value
			qd_reading += qdRead();
			waitfor( DelayMs( SAMPLEINTERVAL ) );
		}
      /***********************************************************************
       * Simulate Input Capture
       **********************************************************************/
		costate
      {   //take IC simulated counter value
         icx_getcounts();
         IC1counter = IC1counter ;
         IC2counter = IC2counter ;
        	waitfor( DelayMs(SAMPLEINTERVAL));
      }
	}
}


